function j=Ja(x,y,costheta, a)
%H-L Eq.(6.36) p.165

if(a==0)
    j=0;
    return;
end

R=Rf(x,y,costheta,a);
u=x-y+R;
v=y-x+R;
w=x+y+R;

theta=acos(costheta);
ta2=tan(theta/2);

if(abs(ta2)<1e-10)
  %disp('Ja: parallel');
  j=-sqrt((x-y)^2+a^2)/a^2;
else
  j=ta2 /(2*a) * (atan(u/a/ta2) + atan(v/a/ta2)) - 1/a/ta2*atan(w/a*ta2);
end

