function T = Tfa(b1, b2, xi1, xi2, e3, costheta, x, y, z, a)
%
%          ^ y axis
%         /
%        -
%    y  /
%      / theta
%       ---------------|----------------> x axis
%           x
%
%       x>0, y>0   ( HL p166, Eq.(6-40) potential error in Last term!)

sintheta = dot(cross(xi1,xi2),e3);

bt1=dot(cross(b1,xi1),xi2); bt2=dot(cross(b2,xi2),xi1);
bt3=dot(cross(b1,xi1),e3 ); bt4=dot(cross(b2,xi2),e3 );

costheta2 = costheta*costheta;
sintheta2 = 1-costheta2;
sintheta4 = sintheta2*sintheta2;

ap=sqrt(z^2+a^2);

L1=-Rf(x,y,costheta,ap)*costheta-y*sintheta2*log(s(x,y,costheta,ap));
L2=-Rf(x,y,costheta,ap)*costheta-x*sintheta2*log(t(x,y,costheta,ap));

T=  -bt1*bt2*costheta/sintheta4*(L1+L2) ...
    -bt1*bt2*(1+costheta2)/sintheta4*Rf(x,y,costheta,ap) ...
    +(bt3*bt2-bt1*bt4*costheta)*z/sintheta2 * (-log(t(x,y,costheta,ap))) ...
    +(bt3*bt2*costheta-bt1*bt4)*z/sintheta2 * (-log(s(x,y,costheta,ap))) ...
    +bt3*bt4*( Ia(x,y,costheta,ap) - (z^2)*Ja(x,y,costheta,ap) );

%when Iab incorporates Jab
%   +bt3*bt4*( Ia(x,y,costheta,ap) - (z^2+a^2/2)*Ja(x,y,costheta,ap) );

%[bt1*bt2,(bt3*bt2-bt1*bt4*costheta),(bt3*bt2*costheta-bt1*bt4),bt3*bt4]'
%[bt1,bt2,bt3,bt4]'
%bt3*bt4