%analytic expression for edge dislocation self energy

r=sym('r');
t=sym('t');
a=sym('a');
n=sym('n');
R=sym('R');

x=r*cos(t);
y=r*sin(t);

sxx=  -y*(3*x^2+y^2+3*a^2)/(x^2+y^2+a^2)^2;
syy=   y*(  x^2-y^2-  a^2)/(x^2+y^2+a^2)^2;
szz=-2*n*y*(x^2+y^2+2*a^2)/(x^2+y^2+a^2)^2;
sxy= x*(    x^2-y^2+  a^2)/(x^2+y^2+a^2)^2;

en = sxy^2 + 1/2/(1+n)*( sxx^2+syy^2-szz^2-2*n*sxx*syy );
W = int( int( en, t, 0, 2*pi ), r, 0, R );

%maple
%x:=r*cos(t);
%y:=r*sin(t);
%
%sxx:=  -y*(3*x^2+y^2+3*a^2)/(x^2+y^2+a^2)^2;
%syy:=   y*(  x^2-y^2-  a^2)/(x^2+y^2+a^2)^2;
%szz:=-2*n*y*(x^2+y^2+2*a^2)/(x^2+y^2+a^2)^2;
%sxy:= x*(    x^2-y^2+  a^2)/(x^2+y^2+a^2)^2;
%
%en := sxy^2 + 1/2/(1+n)*( sxx^2+syy^2-szz^2-2*n*sxx*syy );
%W := int( int( en, t=0..2*pi ), r=0..R );

%Mathematica
x:=r*Cos[t]
y:=r*Sin[t]

sxx:=  -y*(3*x^2+y^2+3*a^2)/(x^2+y^2+a^2)^2
syy:=   y*(  x^2-y^2-  a^2)/(x^2+y^2+a^2)^2
szz:=-2*n*y*(x^2+y^2+2*a^2)/(x^2+y^2+a^2)^2
sxy:= x*(    x^2-y^2+  a^2)/(x^2+y^2+a^2)^2

en := sxy^2 + 1/2/(1+n)*( sxx^2+syy^2-szz^2-2*n*sxx*syy )
W := Assuming[ {a>0, R>0}, Integrate[ Integrate[ en*r, {t, 0, 2*Pi}], {r, 0, R} ] ]
FullSimplify[ Series[ W , {a, 0, 3} ] ]


%Dislocation dipole
x1:=x-R/2; x2=x+R/2;

sxx:=  -y*(3*x1^2+y^2+3*a^2)/(x1^2+y^2+a^2)^2 -y*(3*x2^2+y^2+3*a^2)/(x2^2+y^2+a^2)^2    *(-1)
syy:=   y*(  x1^2-y^2-  a^2)/(x1^2+y^2+a^2)^2 +y*(  x2^2-y^2-  a^2)/(x2^2+y^2+a^2)^2    *(-1)
szz:=-2*n*y*(x1^2+y^2+2*a^2)/(x1^2+y^2+a^2)^2 -2*n*y*(x2^2+y^2+2*a^2)/(x2^2+y^2+a^2)^2  *(-1)
sxy:=x1*(    x1^2-y^2+  a^2)/(x1^2+y^2+a^2)^2+x2*(    x2^2-y^2+  a^2)/(x2^2+y^2+a^2)^2  *(-1)

en := sxy^2 + 1/2/(1+n)*( sxx^2+syy^2-szz^2-2*n*sxx*syy )
W := Assuming[ {a>0, R>0}, Integrate[ Integrate[ en*r, {t, 0, 2*Pi}], {r, 0, Infinity} ] ]
FullSimplify[ Series[ W , {a, 0, 3} ] ]
