function W = engnonplanarb2(MU, NU, b1, b2, xi1, xi2, e3, costheta, x1, x2, y1, y2, z, a)
%
%          ^ y axis
%         /
%        -
%    y  /
%      / theta
%       ---------------|----------------> x axis
%           x
%
%       x>0, y>0    HL p164, Eq.(6-32)

ap=sqrt(z*z+a*a);

Iab = Ia(x2,y2,costheta,ap)-Ia(x2,y1,costheta,ap)-Ia(x1,y2,costheta,ap)+Ia(x1,y1,costheta,ap);
Jab = Ja(x2,y2,costheta,ap)-Ja(x2,y1,costheta,ap)-Ja(x1,y2,costheta,ap)+Ja(x1,y1,costheta,ap);

Tab = Tfa(b1,b2,xi1,xi2,e3,costheta,x2,y2,z,a)...
    - Tfa(b1,b2,xi1,xi2,e3,costheta,x2,y1,z,a)...
    - Tfa(b1,b2,xi1,xi2,e3,costheta,x1,y2,z,a)...
    + Tfa(b1,b2,xi1,xi2,e3,costheta,x1,y1,z,a) ;

W = MU/4/pi* (-2*dot(cross(b1,b2),cross(xi1,xi2)) + dot(b1,xi1)*dot(b2,xi2) )*(Iab+a^2/2*Jab) ...
    + MU/4/pi/(1-NU)* Tab;

%when Iab incorporates Jab
%W = MU/4/pi* (-2*dot(cross(b1,b2),cross(xi1,xi2)) + dot(b1,xi1)*dot(b2,xi2) )*(Iab) ...
%    + MU/4/pi/(1-NU)* Tab;
