function W=engself(MU,NU,b,r1,r2,rho,a)
% Computes self energy of a dislocation segment r0-r1 with Burgers vector b
% MU is shear modulus, NU is Poisson ratio, a is core spread radius


if(rho~=0) & (a~=0)
    disp('Error: engself rho and a cannot both be nonzero');
    W=0;
    return;
end

r21=r2-r1;

%make sure dr1, dr2 are column vector
s1=size(r21); if(s1(1)==1) r21=r21'; end

L1=norm(r21);
e1=r21/L1;

bs=dot(b,e1);
be=norm(b-bs*e1);

if(rho~=0)
   W=MU/4/pi *(bs*bs+be*be/(1-NU)) * L1*(log(L1/rho)-1);
else
    La=sqrt(L1*L1+a*a);
    W=MU/8/pi *( bs*bs* (a-La+2*L1*log(a/(La-L1))) ...
               + be*be/(1-NU)* (2*a-2*La+2*L1*log(a/(La-L1))) );
end