function fn=loopcoreforce_analyt(MU,NU,b,rn,a,a0,flag)
% Computes core energy contribution to driving force on all nodes in a dislocation loop,
% The loop is specified by an array of node positions: rn.
% The segment from each node to the next one has Burgers vector b.
% MU is shear modulus, NU is Poisson ratio, a is core spread radius.
%
% For debugging purposes,
% if flag == 1, only radial component is included
% if flag == 2, only theta component is included
% otherwise both components are included
%
% Uses function: coreforce

fn=zeros(size(rn));

%N: number of nodes
[N,m]=size(rn);
if(m~=3)
    disp('r should have 3 columns!');
    return;
end

fs=fn; %self force   (contribution from self stress)

%self force
for i1=1:N,
    i0=mod(i1-2+N,N)+1;
    [f0,f1]=coreforce(MU,NU,b,rn(i0,:)',rn(i1,:)',a,a0,flag);
    fs(i0,:)=fs(i0,:)+f0';
    fs(i1,:)=fs(i1,:)+f1';
end

fn=fs;