function sig=loopstress(MU,NU,b,rn,a,r)
% Computes stress field of a dislocation loop at field point r,
% The loop is specified by an array of node positions: rn.
% The segment from each node to the next one has Burgers vector b.
% MU is shear modulus, NU is Poisson ratio, a is core spread radius.

%N: number of nodes
[N,m]=size(rn);
if(m~=3)
    disp('r should have 3 columns!');
    return;
end

sig=zeros(3,3);
%loop through all segments
for i1=1:N,
    i0=mod(i1-2+N,N)+1;
    s=calsegstr3da(MU, NU, b, rn(i0,:)',rn(i1,:)', r, a);
    sig=sig+s;
end

