%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% testloop2a.m
%
% Test core energy contribution to node force
%  based on testloop2.m
%
% force are computed in two ways:
%  by analytic expression for core radius a0
%  by analytic expression for core radius a + core contribution
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Preparing the loop coordinates
%N=6;
%N=12;
%N=24;
N=100;
theta=[0:N-1]'/N*(2*pi);
R=10;
%R=50;

%circular loop
rn=R*[cos(theta),sin(theta),zeros(size(theta))]; %circular loop
b =[1 0 0]';                                     %glide loop

%for plotting
phi=[0:1000]'/1000*(2*pi);
rs=R*[cos(phi),sin(phi),zeros(size(phi))];

%random loop
%rn=R*rand(size(rn));                            %random loop
%b =rand(3,1);                                   %random loop

%Material constants
a0=0.1;
a =2;
MU=1;
NU=0.3;

%********************
% LOOPNODEFORCE
%********************
Delta=1e-2;
i=2;
disp('loopnodeforce_analyt...');
fna0=loopnodeforce_analyt(MU,NU,b,rn,a0);
fna0r=sum((fna0.*rn)/R,2);

fna=loopnodeforce_analyt(MU,NU,b,rn,a);
fnar=sum((fna.*rn)/R,2);

fnac_radial=loopcoreforce_analyt(MU,NU,b,rn,a,a0,1);
fnacr_radial=sum((fnac_radial.*rn)/R,2);

fnac_theta=loopcoreforce_analyt(MU,NU,b,rn,a,a0,2);
fnacr_theta=sum((fnac_theta.*rn)/R,2);

fnacr=fnacr_radial+fnacr_theta;

figure(1);
plot(rn(:,1),rn(:,2),'ro',rn([1:N,1],1),rn([1:N,1],2),'b-',rs(:,1),rs(:,2),':');
axis equal
fs=24;
set(gca,'FontSize',fs);
xlabel('x');
ylabel('y');

figure(2);
plot(theta/(2*pi),fna0r,'ro-', theta/(2*pi),fnar,'b^-', ...
   theta/(2*pi),fnar+fnacr_radial,'bx-', ...
   theta/(2*pi),fnar+fnacr,'b.-' );
fs=24;
set(gca,'FontSize',fs);
%ylim([-0.4, -0.2]);
xlabel('\theta / (2\pi)');
ylabel('f_r');


