%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% testremoteforce.m
%
% benchmark remoteforce_strint and remoteforce_analyt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

r0=rand(3,1);
r1=rand(3,1);
r2=rand(3,1);
r3=rand(3,1);
b01=rand(3,1);
b23=rand(3,1);

a=0.1;
nsub=2;
loop=1;

t=cputime; f=flops;
for iloop=1:loop,
[f0,f1]=remoteforce_strint(MU,NU,b01,r0,r1,b23,r2,r3,a,nsub);
[f2,f3]=remoteforce_strint(MU,NU,b23,r2,r3,b01,r0,r1,a,nsub);
end
tstr=cputime-t; fstr=flops-f;

t=cputime; f=flops;
for i=1:loop,
[f0a,f1a,f2a,f3a]=remoteforce_analyt(MU,NU,b01,r0,r1,b23,r2,r3,a);
end
tanl=cputime-t; fanl=flops-f;

disp(sprintf('remoteforce_strint f%d = (%25.15e,%25.15e,%25.15e)',0,f0(1),f0(2),f0(3)));
disp(sprintf('remoteforce_analyt f%d = (%25.15e,%25.15e,%25.15e)',0,f0a(1),f0a(2),f0a(3)));

disp(sprintf('remoteforce_strint cputime = %e flops=%d',tstr,fstr));
disp(sprintf('remoteforce_analyt cputime = %e flops=%d',tanl,fanl));
